Groups/Regular Endpoints (2022/06)
Use these endpoints to manage groups on the network.
Base URL for these endpoints: https://api.bsn.cloud/2022/06/REST/Groups/Regular
_________________________________________________________________________
GET /
Retrieves a list of groups on the network.
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Query String Parameters
- filter string optional: An expressionexpression for filtering search results. The default value is null.
- sort string optional: An expression for sorting the search results. The sort expression specifies the entry used for sorting and the ascending/descending (ASC/DESC) sorting order (see this pagethis page for more information). The default value is null.
- marker string optional: A value specifying which page to retrieve. This value is useful if the isTruncated entry in the response body of the previous GET call indicates that the number of group instances exceeds the pageSize. This parameter is only required if you need more elements in the paged list than the pageSize (100).
- pageSize int optional: The maximum number of group instances that can be contained in the response body. This defaults to the maximum allowed page size (100).
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- marker value is set to [PagedList].[NextMarker] property value from the previous BSN.cloud API response.
- pageSize is set to 1
- filter is set to [CreationDate] IS IN THE RANGE '2020-07-01' AND '2023-08-01'
- sort is set to [Name] ASC
GET /2022/06/REST/Groups/Regular/?marker=YXVkaW8tdGVzdCwyNjQ1Mjg%3D&pageSize=1&filter=%5BCreationDate%5D%20IS%20IN%20THE%20RANGE%20%272020-07-01%27%20AND%20%272023-08-01%27&sort=%5BName%5D%20ASC HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns a paged listpaged list of Regular Groups Entity instances on a network. This will return not more than 100 entities along with the information necessary to return any other remaining pages.
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
POST /
Creates a group on the network.
Required Scope Token
bsn.api.main.groups.regular.create
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
POST /2022/06/REST/Groups/Regular/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 1053This is the example request body:
{
"id": 0,
"name": "NewGroup",
"creationDate": "0001-01-01T00:00:00.000Z",
"lastModifiedDate": "0001-01-01T00:00:00.000Z",
"autorun": null,
"hdX23Firmware": "",
"hdX23FirmwareId": -1,
"lsX23Firmware": "",
"lsX23FirmwareId": -1,
"hsX23Firmware": "",
"hsX23FirmwareId": -1,
"hoX23Firmware": "",
"hoX23FirmwareId": -1,
"xdX33Firmware": "",
"xdX33FirmwareId": -1,
"xtX43Firmware": "",
"xtX43FirmwareId": -1,
"xdX34_XTX44Firmware": "",
"xdX34_XTX44FirmwareId": -1,
"hdX4_HSX4_LSX4Firmware": "8.5.47",
"hdX4_HSX4_LSX4FirmwareId": -1,
"4KX42Firmware": "",
"4KX42FirmwareId": -1,
"enableSerialDebugging": false,
"enableSystemLogDebugging": false,
"enableStorageSpaceLimit": false,
"storageSpaceLimitUnits": "Percentage",
"publishedDataSizeLimit": 0,
"dynamicDataSizeLimit": 0,
"htmlDataSizeLimit": 0,
"htmlLocalStorageSizeLimit": 0,
"webDatabaseSizeLimit": 0,
"devicesCount": 0,
"devicesHealthStatus": null,
"devices": null,
"schedule": null,
"permissions": []
}______________________________________________________________
Success Response Body
201: Returns the Regular Groups Entity created and referenced by the Uri (given by the Location header field) in the response.
Example
{
"id": 123456,
"name": "NewGroup",
"creationDate": "2023-10-19T20:30:35.833Z",
"lastModifiedDate": "2023-10-19T20:30:35.833Z",
"autorun": null,
"hdX23Firmware": "",
"hdX23FirmwareId": -1,
"lsX23Firmware": "",
"lsX23FirmwareId": -1,
"hsX23Firmware": "",
"hsX23FirmwareId": -1,
"hoX23Firmware": "",
"hoX23FirmwareId": -1,
"xdX33Firmware": "",
"xdX33FirmwareId": -1,
"xtX43Firmware": "",
"xtX43FirmwareId": -1,
"xdX34_XTX44Firmware": "",
"xdX34_XTX44FirmwareId": -1,
"hdX4_HSX4_LSX4Firmware": "8.5.47",
"hdX4_HSX4_LSX4FirmwareId": 12345,
"auX5Firmware": "",
"auX5FirmwareId": -1,
"4KX42Firmware": "",
"4KX42FirmwareId": -1,
"xcX55Firmware": "",
"xcX55FirmwareId": -1,
"xtX45_XDX35_HDX25_LS4X5_HS1X5Firmware": "",
"xtX45_XDX35_HDX25_LS4X5_HS1X5FirmwareId": -1,
"enableSerialDebugging": false,
"enableSystemLogDebugging": false,
"enableStorageSpaceLimit": false,
"storageSpaceLimitUnits": "Percentage",
"publishedDataSizeLimit": 0,
"dynamicDataSizeLimit": 0,
"htmlDataSizeLimit": 0,
"htmlLocalStorageSizeLimit": 0,
"webDatabaseSizeLimit": 0,
"devicesCount": 0,
"devicesHealthStatus": {},
"devices": null,
"schedule": [],
"permissions": []
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /
Removes groups, specified by a filter, from a network. This allows multiple groups to be deleted at once.
Required Scope Token
bsn.api.main.groups.regular.delete
______________________________________________________________
Query String Parameter
- reassignmentGroupId int optional: The identifier of the group instance to which affected devices should be reassigned. If this value is negative, the devices will be reassigned to the default “Unassigned” group instance. If a group instance with the specified positive [int] Id does not exist, the method will return a descriptive error. The default value is 0.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- filter is set to [DevicesCount] IS 0
- reassignmentGroupId is set to 12345
DELETE /2022/06/REST/Groups/Regular/?reassignmentGroupId=12345&filter=%5BDevicesCount%5D%20IS%200 HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns the number of affected groups as an integer value.
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
GET /Count/
Returns the number of groups on the network that match the specified filter criteria. If no filter is included, this call returns the total number of groups on the network.
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Query String Parameter
- filter string optional: An expressionexpression for filtering search results. The default value is null.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- filter is set to [Name] CONTAINS 'test'
GET /2022/06/REST/Groups/Regular/Count/?filter=%5BName%5D%20CONTAINS%20%27test%27 HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: The number of groups is returned as an integer value.
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
GET /{id}/
Returns a specified group
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- id int: The unique identifier for the group
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to 12345
- The optional If-Modified-Since header value equals the Last-Modified header value retrieved from the previous GET /id or GET /name response
GET /2022/06/REST/Groups/Regular/12345/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Modified-Since: Wed, 20 Dec 2023 21:32:34 GMT______________________________________________________________
Success Response with Body
200: Returns the Regular Groups Entity
Example
This is an example of a 200 level response:
{
"id": 12345,
"name": "ConferenceRoom",
"creationDate": "2023-12-11T22:24:51.347Z",
"lastModifiedDate": "2023-12-20T21:32:35.093Z",
"autorun": null,
"hdX23Firmware": "",
"hdX23FirmwareId": -1,
"lsX23Firmware": "",
"lsX23FirmwareId": -1,
"hsX23Firmware": "",
"hsX23FirmwareId": -1,
"hoX23Firmware": "",
"hoX23FirmwareId": -1,
"xdX33Firmware": "",
"xdX33FirmwareId": -1,
"xtX43Firmware": "",
"xtX43FirmwareId": -1,
"xdX34_XTX44Firmware": "",
"xdX34_XTX44FirmwareId": -1,
"hdX4_HSX4_LSX4Firmware": "",
"hdX4_HSX4_LSX4FirmwareId": -1,
"auX5Firmware": "",
"auX5FirmwareId": -1,
"4KX42Firmware": "",
"4KX42FirmwareId": -1,
"xcX55Firmware": "",
"xcX55FirmwareId": -1,
"xtX45_XDX35_HDX25_LS4X5_HS1X5Firmware": "",
"xtX45_XDX35_HDX25_LS4X5_HS1X5FirmwareId": -1,
"enableSerialDebugging": true,
"enableSystemLogDebugging": false,
"enableStorageSpaceLimit": false,
"storageSpaceLimitUnits": "Percentage",
"publishedDataSizeLimit": 0,
"dynamicDataSizeLimit": 0,
"htmlDataSizeLimit": 0,
"htmlLocalStorageSizeLimit": 0,
"webDatabaseSizeLimit": 0,
"devicesCount": 2,
"devicesHealthStatus": {
"normal": 1,
"error": 1
},
"devices": [
{
"id": 12345,
"serial": "XXXXXX000000"
},
{
"id": 67890,
"serial": "YYYYYY000000"
}
],
"schedule": [],
"permissions": []
}Success Response
304: The resource was not modified since the time specified in the If-Modified-Since header
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
PUT /{id}/
Updates the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- id int: The unique identifier for the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to 12345
- The optional If-Unmodified-Since header value equals the Last-Modified header value retrieved from the GET /id or GET /name response.
PUT /2022/06/REST/Groups/Regular/12345/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Unmodified-Since: Wed, 20 Dec 2023 21:32:34 GMT
Content-Type: application/json
Content-Length: 1785This is the example request body:
{
"id": 0,
"name": "Default",
"creationDate": "0001-01-01T00:00:00",
"lastModifiedDate": "0001-01-01T00:00:00",
"autorun": null,
"hdX23Firmware": "",
"hdX23FirmwareId": -1,
"lsX23Firmware": "",
"lsX23FirmwareId": -1,
"hsX23Firmware": "",
"hsX23FirmwareId": -1,
"hoX23Firmware": "",
"hoX23FirmwareId": -1,
"xdX33Firmware": "",
"xdX33FirmwareId": -1,
"xtX43Firmware": "",
"xtX43FirmwareId": -1,
"xdX34_XTX44Firmware": "",
"xdX34_XTX44FirmwareId": -1,
"hdX4_HSX4_LSX4Firmware": "8.5.47",
"hdX4_HSX4_LSX4FirmwareId": -1,
"auX5Firmware": "",
"auX5FirmwareId": -1,
"4KX42Firmware": "",
"4KX42FirmwareId": -1,
"xcX55Firmware": "",
"xcX55FirmwareId": -1,
"xtX45_XDX35_HDX25_LS4X5_HS1X5Firmware": "",
"xtX45_XDX35_HDX25_LS4X5_HS1X5FirmwareId": -1,
"enableSerialDebugging": false,
"enableSystemLogDebugging": true,
"enableStorageSpaceLimit": false,
"storageSpaceLimitUnits": "Percentage",
"publishedDataSizeLimit": 0,
"dynamicDataSizeLimit": 0,
"htmlDataSizeLimit": 0,
"htmlLocalStorageSizeLimit": 0,
"webDatabaseSizeLimit": 0,
"devicesCount": 0,
"devicesHealthStatus": null,
"devices": null,
"schedule": null,
"permissions": []
}______________________________________________________________
Success Response
204: The specified group has been updated
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
412: Precondition failed (the resource/group changed since the time specified in the “If-Unmodified-Since” header value)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
PATCH /{id}/
Applies a sequence of changes to a specific group entity specified by id. See RFC 6902.
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- id int: The identifier for the group entity, which is a resource Uri
______________________________________________________________
Request Body
These properties are entries in an array. Every entry must have all three of these properties:
- op string: The type of operation - in this case it is always "replace"
- path string: A Uri path that references the location within the target document where the update will be performed
- value object: The replacement value(s) for the parameters that must be updated. This can be an array.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is 12345
- The optional If-Unmodified-Since header value equals the Last-Modified header value retrieved from the GET /id or GET /name response.
PATCH /2022/06/REST/Groups/Regular/12345/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Unmodified-Since: Wed, 20 Dec 2023 21:32:34 GMT
Content-Type: application/json-patch+json
Content-Length: 91This is the example request body:
[
{
"op": "replace",
"path": "/xdX34_XTX44Firmware/",
"value": "8.5.33"
}
]______________________________________________________________
Success Response
204: The parameters have been successfully replaced.
Failure Response
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
412: Precondition failed (the resource changed since the time specified in the “If-Unmodified-Since” header value)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /{id}/
Removes the specified group
Required Scope Token
bsn.api.main.groups.regular.delete
______________________________________________________________
Segment
- id int: The unique identifier for the group
______________________________________________________________
Query String Parameter
- reassignmentGroupId int optional: The identifier of the group instance to which affected devices should be reassigned. If this value is negative, the devices will be reassigned to the default “Unassigned” group instance. If a group instance with the specified positive [int] Id does not exist, the method will return a descriptive error. The default value is 0.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to 12345
- reassignmentGroupId is set to 90
- The optional If-Unmodified-Since header value equals the Last-Modified header value retrieved from the GET /id or GET /name response.
DELETE /2022/06/REST/Groups/Regular/12345/?reassignmentGroupId=90 HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Unmodified-Since: Wed, 20 Dec 2023 21:32:34 GMT______________________________________________________________
Success Response
204: The specified group has been removed from the network
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
412: Precondition failed (the resource changed since the time specified in the “If-Unmodified-Since” header value)
5XX: Any 500 code is an internal server error
GET /{name}/
Returns a specified group
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- name string: The name of the group
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- name is set to ConferenceRoom
- The optional If-Modified-Since header value equals the Last-Modified header value retrieved from the previous GET /id or GET /name response
GET /2022/06/REST/Groups/Regular/ConferenceRoom/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Modified-Since: Wed, 20 Dec 2023 21:32:34 GMT______________________________________________________________
Success Response with Body
200: Returns the Regular Groups Entity
Example
This is an example of a 200 level response:
{
"id": 456789,
"name": "ConferenceRoom",
"creationDate": "2023-12-11T22:24:51.347Z",
"lastModifiedDate": "2023-12-20T21:32:35.093Z",
"autorun": null,
"hdX23Firmware": "",
"hdX23FirmwareId": -1,
"lsX23Firmware": "",
"lsX23FirmwareId": -1,
"hsX23Firmware": "",
"hsX23FirmwareId": -1,
"hoX23Firmware": "",
"hoX23FirmwareId": -1,
"xdX33Firmware": "",
"xdX33FirmwareId": -1,
"xtX43Firmware": "",
"xtX43FirmwareId": -1,
"xdX34_XTX44Firmware": "",
"xdX34_XTX44FirmwareId": -1,
"hdX4_HSX4_LSX4Firmware": "",
"hdX4_HSX4_LSX4FirmwareId": -1,
"auX5Firmware": "",
"auX5FirmwareId": -1,
"4KX42Firmware": "",
"4KX42FirmwareId": -1,
"xcX55Firmware": "",
"xcX55FirmwareId": -1,
"xtX45_XDX35_HDX25_LS4X5_HS1X5Firmware": "",
"xtX45_XDX35_HDX25_LS4X5_HS1X5FirmwareId": -1,
"enableSerialDebugging": true,
"enableSystemLogDebugging": false,
"enableStorageSpaceLimit": false,
"storageSpaceLimitUnits": "Percentage",
"publishedDataSizeLimit": 0,
"dynamicDataSizeLimit": 0,
"htmlDataSizeLimit": 0,
"htmlLocalStorageSizeLimit": 0,
"webDatabaseSizeLimit": 0,
"devicesCount": 2,
"devicesHealthStatus": {
"normal": 1,
"error": 1
},
"devices": [
{
"id": 12345,
"serial": "XXXXXX000000"
},
{
"id": 67890,
"serial": "YYYYYY000000"
}
],
"schedule": [],
"permissions": []
}Success Response
304: The resource was not modified since the time specified in the “If-Modified-Since” header
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
PUT /{name}/
Updates a specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- name string: The name of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- name is set to Default
- The optional If-Unmodified-Since header value equals the Last-Modified header value retrieved from the GET /id or GET /name response.
PUT /2022/06/REST/Groups/Regular/Default/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Unmodified-Since: Wed, 20 Dec 2023 21:32:34 GMT
Content-Type: Content-Type: application/json-patch+json
Content-Length: 1785This is the example request body:
{
"id": 0,
"name": "Default",
"creationDate": "0001-01-01T00:00:00",
"lastModifiedDate": "0001-01-01T00:00:00",
"autorun": null,
"hdX23Firmware": "",
"hdX23FirmwareId": -1,
"lsX23Firmware": "",
"lsX23FirmwareId": -1,
"hsX23Firmware": "",
"hsX23FirmwareId": -1,
"hoX23Firmware": "",
"hoX23FirmwareId": -1,
"xdX33Firmware": "",
"xdX33FirmwareId": -1,
"xtX43Firmware": "",
"xtX43FirmwareId": -1,
"xdX34_XTX44Firmware": "",
"xdX34_XTX44FirmwareId": -1,
"hdX4_HSX4_LSX4Firmware": "8.5.47",
"hdX4_HSX4_LSX4FirmwareId": -1,
"auX5Firmware": "",
"auX5FirmwareId": -1,
"4KX42Firmware": "",
"4KX42FirmwareId": -1,
"xcX55Firmware": "",
"xcX55FirmwareId": -1,
"xtX45_XDX35_HDX25_LS4X5_HS1X5Firmware": "",
"xtX45_XDX35_HDX25_LS4X5_HS1X5FirmwareId": -1,
"enableSerialDebugging": false,
"enableSystemLogDebugging": true,
"enableStorageSpaceLimit": false,
"storageSpaceLimitUnits": "Percentage",
"publishedDataSizeLimit": 0,
"dynamicDataSizeLimit": 0,
"htmlDataSizeLimit": 0,
"htmlLocalStorageSizeLimit": 0,
"webDatabaseSizeLimit": 0,
"devicesCount": 0,
"devicesHealthStatus": null,
"devices": null,
"schedule": null,
"permissions": []
}______________________________________________________________
Success Response
204: The specified group has been updated
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
412: Precondition failed (the resource/group changed since the time specified in the “If-Unmodified-Since” header value)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
PATCH /{name}/
Applies a sequence of changes to a specific group entity specified by name. See RFC 6902.
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- name string: The name of the group entity, which is a resource Uri
______________________________________________________________
Request Body
These properties are entries in an array. Every entry must have all three of these properties:
- op string: The type of operation - in this case it is always "replace"
- path string: A Uri path that references the location within the target document where the update will be performed
- value object: The replacement value(s) for the parameters that must be updated. This can be an array.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- name is Default
- The optional If-Unmodified-Since header value equals the Last-Modified header value retrieved from the GET /id or GET /name response.
PATCH /2022/06/REST/Groups/Regular/Default/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Unmodified-Since: Wed, 20 Dec 2023 21:32:34 GMT
Content-Type: application/json-patch+json
Content-Length: 91This is the example request body:
[
{
"op": "replace",
"path": "/xdX34_XTX44Firmware/",
"value": "8.5.33"
}
]______________________________________________________________
Success Response
204: The parameters have been successfully replaced.
Failure Response
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
412: Precondition failed (the resource changed since the time specified in the “If-Unmodified-Since” header value)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /{name}/
Removes a specified group
Required Scope Token
bsn.api.main.groups.regular.delete
______________________________________________________________
Segment
- name string: The name of the group
______________________________________________________________
Query String Parameter
- reassignmentGroupId int optional: The identifier of the group instance to which affected devices should be reassigned. If this value is negative, the devices will be reassigned to the default “Unassigned” group instance. If a group instance with the specified positive [int] Id does not exist, the method will return a descriptive error. The default value is 0.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to Default
- reassignmentGroupId is set to 90
- The optional If-Unmodified-Since header value equals the Last-Modified header value retrieved from the GET /id or GET /name response.
DELETE /2022/06/REST/Groups/Regular/Default/?reassignmentGroupId=90 HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
If-Unmodified-Since: Wed, 20 Dec 2023 21:32:34 GMT______________________________________________________________
Success Response
204: The specified group has been removed from the network
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
412: Precondition failed (the resource changed since the time specified in the “If-Unmodified-Since” header value)
5XX: Any 500 code is an internal server error
GET /{Id}/Schedule/
Returns a list of the Scheduled Presentation Entity in the specified group
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- groupId int: The unique identifier of the group
______________________________________________________________
Query String Parameter
- marker string optional: A value specifying which page to retrieve. This value is useful if the isTruncated entry in the response body of the previous GET call indicates that the number of group instances exceeds the pageSize.
- pageSize int optional: The maximum number of group instances that can be contained in the response body.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupId is set to 12345
- pageSize is set to 1
- marker value is set to the [PagedList].[NextMarker] property value from the previous BSN.cloud API response.
GET /2022/06/REST/Groups/Regular/12345/Schedule/?marker=Zy023g2B8&pageSize=1 HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns a list of the scheduled presentations of the specified group
Example
{
"items": [ {
"id": 2345678,
"presentationId": 123456,
"presentationName": "October2023Prez",
"isRecurrent": false,
"eventDate": "2023-11-03T00:00:00",
"startTime": "00:00:00",
"duration": "23:59:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "None",
"creationDate": "2023-11-03T21:04:32.81Z",
"lastModifiedDate": "2023-11-03T21:04:32.81Z",
"expirationDate": "2023-11-04T11:59:00Z",
"interruptScheduling": false
}],
"totalItemCount": 3,
"matchingItemCount": 3,
"pageSize": 1,
"nextMarker": "GWpbWFcsw15NjI5MjN0",
"prevMarker": "GWpbWFcsw15NjI5hu8u",
"isTruncated": true,
"sortExpression": "[ScheduledPresentation].[ExpireDate] DESC",
"filterExpression": null
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
POST /{Id}/Schedule/
Adds a scheduled presentation to the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- groupId int: The unique identifier of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupId is set to 12345
POST /2022/06/REST/Groups/Regular/12345/Schedule/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 419This is the example request body:
{
"id": 0,
"presentationId": 23456,
"presentationName": "October2023Prez",
"isRecurrent": false,
"eventDate": "2023-11-04T00:00:00",
"startTime": "00:00:00",
"duration": "23:59:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "None",
"creationDate": "0001-01-01T00:00:00",
"lastModifiedDate": "0001-01-01T00:00:00",
"expirationDate": null,
"interruptScheduling": false
}______________________________________________________________
Success Response Body
201: Returns the new resource created and referenced by the Uri (given by the Location header field) in the response. The response includes the Scheduled Presentation Entity.
Example
{
"id": 1234567,
"presentationId": 23456,
"presentationName": "October2023Prez",
"isRecurrent": false,
"eventDate": "2023-11-04T00:00:00",
"startTime": "00:00:00",
"duration": "23:59:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "None",
"creationDate": "2023-11-03T18:14:09.3506335Z",
"lastModifiedDate": "2023-11-03T18:14:09.3506335Z",
"expirationDate": "2023-11-05T11:59:00Z",
"interruptScheduling": false
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
GET /{name}/Schedule/
Returns a list of the Scheduled Presentation Entity in the specified group
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- groupName string: The name of the group
______________________________________________________________
Query String Parameters
- marker string optional: A value specifying which page to retrieve. This value is useful if the isTruncated entry in the response body of the previous GET call indicates that the number of group instances exceeds the pageSize.
- pageSize int optional: The maximum number of group instances that can be contained in the response body.
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupName is set to October2023Prez
- pageSize is set to 1
- marker value is set to the [PagedList].[NextMarker] property value from the previous BSN.cloud API response.
GET /2022/06/REST/Groups/Regular/October2023Prez/Schedule/?marker=RGVmYXVsdMDkxNA&pageSize=1 HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns a list of the scheduled presentations of the specified group
Example
{
"items": [ {
"id": 2345678,
"presentationId": 123456,
"presentationName": "October2023Prez",
"isRecurrent": true,
"eventDate": null,
"startTime": "00:00:00",
"duration": "1.00:00:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "EveryDay",
"creationDate": "2023-10-20T21:11:48.233Z",
"lastModifiedDate": "2023-10-20T21:11:48.233Z",
"expirationDate": null,
"interruptScheduling": false
}],
"totalItemCount": 3,
"matchingItemCount": 3,
"pageSize": 1,
"nextMarker": "GWpbWFcsw15NjI5MjN0",
"prevMarker": "GWpbWFcsw15NjI58901",
"isTruncated": true,
"sortExpression": "[ScheduledPresentation].[ExpireDate] DESC",
"filterExpression": null
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
POST /{name}/Schedule/
Adds a scheduled presentation to the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- groupName string: The name of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupName is set to October2023Prez
POST /2022/06/REST/Groups/Regular/October2023Prez/Schedule/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 419This is the example request body:
{
"id": 0,
"presentationId": 123456,
"presentationName": "October2023Prez",
"isRecurrent": false,
"eventDate": "2023-11-04T00:00:00",
"startTime": "00:00:00",
"duration": "23:59:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "None",
"creationDate": "0001-01-01T00:00:00",
"lastModifiedDate": "0001-01-01T00:00:00",
"expirationDate": null,
"interruptScheduling": false
}______________________________________________________________
Success Response Body
201: Returns the new resource created and referenced by the Uri (given by the Location header field) in the response. The response includes the Scheduled Presentation Entity .
Example
{
"id": 2345678,
"presentationId": 23456,
"presentationName": "October2023Prez",
"isRecurrent": false,
"eventDate": "2023-11-04T00:00:00",
"startTime": "00:00:00",
"duration": "23:59:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "None",
"creationDate": "2023-11-03T18:14:09.3506335Z",
"lastModifiedDate": "2023-11-03T18:14:09.3506335Z",
"expirationDate": "2023-11-05T11:59:00Z",
"interruptScheduling": false
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
GET /{id}/Schedule/{scheduledPresentationId}/
Returns the schedule of the specified presentation in the specified group
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
groupId int: The unique identifier of the group
scheduledPresentationId int: The unique identifier for the scheduled presentation
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupId is set to 12345
- scheduledPresentationId is set to 234567
GET /2022/06/REST/Groups/Regular/12345/Schedule/234567/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns the Scheduled Presentation Entity
Example
{
"id": 234567,
"presentationId": 1234567,
"presentationName": "Default",
"isRecurrent": true,
"eventDate": null,
"startTime": "00:00:00",
"duration": "1.00:00:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "EveryDay",
"creationDate": "2023-10-19T17:21:32.767Z",
"lastModifiedDate": "2023-10-19T17:21:32.767Z",
"expirationDate": null,
"interruptScheduling": false
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
PUT /{id}/Schedule/{scheduledPresentationId}/
Updates the specified scheduled presentation in the specified group.
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- groupId int: The unique identifier of the group
- scheduledPresentationId int: The unique identifier for the scheduled presentation
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupId is set to 12345
- scheduledPresentationId is set to 234567
PUT /2022/06/REST/Groups/Regular/12345/Schedule/234567/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 443This is the example request body:
{
"id": 0,
"presentationId": 1234567,
"presentationName": "Default",
"isRecurrent": true,
"eventDate": null,
"startTime": "00:00:00",
"duration": "1.00:00:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "EveryDay",
"creationDate": "0001-01-01T00:00:00",
"lastModifiedDate": "0001-01-01T00:00:00",
"expirationDate": null,
"interruptScheduling": false
}______________________________________________________________
Success Response
204: The scheduled presentation in the specified group has been updated
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /{id}/Schedule/{scheduledPresentationId}/
Removes a specified scheduled presentation from the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- groupId int: The unique identifier of the group
- scheduledPresentationId int: The unique identifier for the scheduled presentation
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupId is set to 12345
- scheduledPresentationId is set to 234567
DELETE /2022/06/REST/Groups/Regular/12345/Schedule/234567/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response
204: The scheduled presentation has been deleted from the specified group
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
GET /{name}/Schedule/{scheduledPresentationId}/
Returns the schedule of the specified presentation in the specified group
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- groupName string: The name of the group
- scheduledPresentationId int: The unique identifier for the scheduled presentation
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupName is set to Default
- scheduledPresentationId is set to 234567
GET /2022/06/REST/Groups/Regular/Default/Schedule/234567/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns the Scheduled Presentation Entity.
Example
{
"id": 234567,
"presentationId": 987654,
"presentationName": "Default",
"isRecurrent": true,
"eventDate": null,
"startTime": "00:00:00",
"duration": "1.00:00:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "EveryDay",
"creationDate": "2023-10-19T17:21:32.767Z",
"lastModifiedDate": "2023-10-19T17:21:32.767Z",
"expirationDate": null,
"interruptScheduling": false
}Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
PUT /{name}/Schedule/{scheduledPresentationId}/
Updates the specified scheduled presentation in the specified group.
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- groupName string: The name of the group
- scheduledPresentationId int: The unique identifier for the scheduled presentation
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupName is set to Default
- scheduledPresentationId is set to 234567
PUT /2022/06/REST/Groups/Regular/Default/Schedule/234567/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 443This is the example request body:
{
"id": 0,
"presentationId": 987654,
"presentationName": "Default",
"isRecurrent": true,
"eventDate": null,
"startTime": "00:00:00",
"duration": "1.00:00:00",
"recurrenceStartDate": null,
"recurrenceEndDate": null,
"daysOfWeek": "EveryDay",
"creationDate": "0001-01-01T00:00:00",
"lastModifiedDate": "0001-01-01T00:00:00",
"expirationDate": null,
"interruptScheduling": false
}______________________________________________________________
Success Response
204: The specified scheduled presentation has been updated in the specified group
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /{name}/Schedule/{scheduledPresentationId}/
Removes the specified scheduled presentation from the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- groupName string: The name of the group
- scheduledPresentationId int: The unique identifier for the scheduled presentation
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- groupName is set to Default
- scheduledPresentationId is set to 234567
DELETE /2022/06/REST/Groups/Regular/Default/Schedule/234567/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response
204: The specified scheduled presentation has been deleted from the specified group
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
GET /Operations/
Returns operational permissions granted to roles for specific business operations
Required Scope Token
bsn.api.main.groups.operations.retrieve
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
GET /2022/06/REST/Groups/Regular/Operations/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns the Business Operations EntityBusiness Operations Entity
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
GET /{id}/Permissions/
Includes object permissions for a given group instance.
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- id int: The unique identifier of the group
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to 56789
GET /2022/06/REST/Groups/Regular/56789/Permissions/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns an array of PermissionPermission entities
Example
[
{
"entityId": 56789,
"operationUID": "67b9b0ab-fb5f-36c4-d598-a71aa8998e4e",
"principal": {
"login": "[email protected]",
"type": "User",
"id": 5432
},
"isFixed": true,
"isInherited": false,
"isAllowed": true,
"creationDate": "2020-06-01T17:13:32.927Z"
},
{
"entityId": 56789,
"operationUID": "d430853f-c05f-61b4-d137-0237a6984032",
"principal": {
"name": "Custom",
"isCustom": true,
"type": "Role",
"id": 12345
},
"isFixed": false,
"isInherited": false,
"isAllowed": false,
"creationDate": "2023-10-27T18:48:11.053Z"
}
]Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
POST /{id}/Permissions/
Adds permissions to the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- id int: The unique identifier of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to 12345
POST /2022/06/REST/Groups/Regular/12345/Permissions/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 343This is the example request body:
{
"entityId": 12345,
"operationUID": "67b9b0ab-fb5f-36c4-d598-a71aa8998e4e",
"principal": {
"login": "[email protected]",
"type": "User",
"id": 12345
},
"isFixed": false,
"isInherited": false,
"isAllowed": true,
"creationDate": "0001-01-01T00:00:00"
}______________________________________________________________
Success Response
204: The permissions were successfully added to the group
Failure Response
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /{id}/Permissions/
Deletes permissions from the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- id int: The unique identifier of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- id is set to 56789
DELETE /2022/06/REST/Groups/Regular/56789/Permissions/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 604This is the example request body:
[
{
"entityId": 56789,
"operationUID": "d430853f-c05f-61b4-d137-0237a6984032",
"principal": {
"name": "Custom",
"isCustom": true,
"type": "Role",
"id": 12345
},
"isFixed": false,
"isInherited": false,
"isAllowed": false,
"creationDate": "2023-10-27T18:48:11.053Z"
}
]______________________________________________________________
Success Response
204: The specified permissions have been removed from the group
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
GET /{name}/Permissions/
Includes object permissions for a given group instance.
Required Scope Token
bsn.api.main.groups.regular.retrieve
______________________________________________________________
Segment
- name string: The name of the group
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- name is set to Device Control
GET /2022/06/REST/Groups/Regular/Device Control/Permissions/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate______________________________________________________________
Success Response Body
200: Returns an array of PermissionPermission entities
Example
[
{
"entityId": 12345,
"operationUID": "67b9b0ab-fb5f-36c4-d598-a71aa8998e4e",
"principal": {
"login": "[email protected]",
"type": "User",
"id": 1234
},
"isFixed": true,
"isInherited": false,
"isAllowed": true,
"creationDate": "2020-06-01T17:13:32.927Z"
},
{
"entityId": 12345,
"operationUID": "d430853f-c05f-61b4-d137-0237a6984032",
"principal": {
"name": "Custom",
"isCustom": true,
"type": "Role",
"id": 12345
},
"isFixed": false,
"isInherited": false,
"isAllowed": false,
"creationDate": "2023-10-27T18:48:11.053Z"
}
]Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request is malformed and therefore invalid
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error
POST /{name}/Permissions/
Adds permissions to the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- name string: The name of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- name is set to Device Control
POST /2022/06/REST/Groups/Regular/Device Control/Permissions/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 343This is the example request body:
{
"entityId": 56789,
"operationUID": "67b9b0ab-fb5f-36c4-d598-a71aa8998e4e",
"principal": {
"login": "[email protected]",
"type": "User",
"id": 12345
},
"isFixed": false,
"isInherited": false,
"isAllowed": true,
"creationDate": "0001-01-01T00:00:00"
}______________________________________________________________
Success Response
204: The permissions were successfully added to the group
Failure Response
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
415: The server cannot accept the data representation that you sent (as specified in the "Content-Type" header)
5XX: Any 500 code is an internal server error
DELETE /{name}/Permissions/
Removes permissions from the specified group
Required Scope Token
bsn.api.main.groups.regular.update
______________________________________________________________
Segment
- name string: The name of the group
______________________________________________________________
Request Body
______________________________________________________________
Request Example
The example request parameters and headers are set as follows:
- name is set to Device Control
DELETE /2022/06/REST/Groups/Regular/Device Control/Permissions/ HTTP/1.1
Host: api.bsn.cloud
Connection: Keep-Alive
Authorization: Bearer {{UserAccessToken}}
Accept: application/json, application/vnd.bsn.error+json
Accept-Encoding: gzip,deflate
Content-Type: application/json
Content-Length: 604This is the example request body:
[
{
"entityId": 12345,
"operationUID": "d430853f-c05f-61b4-d137-0237a6984032",
"principal": {
"name": "Custom",
"isCustom": true,
"type": "Role",
"id": 12345
},
"isFixed": false,
"isInherited": false,
"isAllowed": false,
"creationDate": "2023-10-27T18:48:11.053Z"
}
]______________________________________________________________
Success Response
204: The specified permissions have been removed from the group
Failure Response
300: The requested representation could not be returned because it is ambiguous (there are multiple requested representations)
400: The request or request body is malformed and therefore invalid, or it is rejected in accordance with the business rules
401: The access token is invalid or not specified
403: The supplied access token, though valid, doesn't provide access to this method
404: The server cannot find the requested resource (the path does not exist)
406: The server cannot return the data representation that you requested (as specified in the "Accept" header)
5XX: Any 500 code is an internal server error